public class Either<A,B> {
  private A left;
  private B right;

  private Either() {}

  public static <A,B> Either<A,B> left(A left) {
    Either<A,B> either = new Either<>();
    either.left = left;
    return either;
  }

  public static <A,B> Either<A,B> right(B right) {
    Either<A,B> either = new Either<>();
    either.right = right;
    return either;
  }

  public boolean isLeft() {
    return left != null;
  }

  public boolean isRight() {
    return right != null;
  }

  public <C> C either(Function<A,C> f, Function<B,C> g) {
    if (isLeft())
      return f.apply(left);
    else
      return g.apply(right);
  }

  @Override
  public String toString() {
    if (isLeft())
      return "Left: " + left.toString();
    else
      return "Right: " + right.toString();
  }
}
