import java.util.ArrayList;
import java.util.List;

public class Lists {
  public static <A,B> List<Tuple<A,B>> zip(List<A> xs, List<B> ys) {
    List<Tuple<A,B>> res = new ArrayList<>();

    for (int i = 0; i < xs.size() && i < ys.size(); i++)
      res.add(new Tuple<>(xs.get(i), ys.get(i)));

    return res;
  }

  public static <A,B> List<B> map(Function<A,B> f, List<A> xs) {
    List<B> res = new ArrayList<>();

    for (A x : xs)
      res.add(f.apply(x));

    return res;
  }

  public static <A> List<A> filter(Function<A,Boolean> p, List<A> xs) {
    List<A> res = new ArrayList<>();

    for (A x : xs)
      if (p.apply(x))
        res.add(x);

    return res;
  }
}
